RuntimeServices (Velocity 1.7 API)
Keywords: org.apache.velocity.runtime.RuntimeServices interface

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime
Interface RuntimeServices

All Superinterfaces:
  RuntimeLogger

All Known Implementing Classes:
  RuntimeInstance

public interface RuntimeServices
extends RuntimeLogger

Interface for internal runtime services that are needed by the various components w/in Velocity. This was taken from the old Runtime singleton, and anything not necessary was removed. Currently implemented by RuntimeInstance.

Version:
  $Id: RuntimeServices.java 898050 2010-01-11 20:15:31Z nbubna $
Author:
  Geir Magusson Jr.

Method Summary
`void` | `addProperty(String key, Object value)` Add a property to the configuration.
`boolean` | `addVelocimacro(String name, Node macro, String[] argArray, String sourceTemplate)` Adds a new Velocimacro.
`boolean` | `addVelocimacro(String name, String macro, String[] argArray, String sourceTemplate)` Deprecated. Use addVelocimacro(String, Node, String[], String) instead
`void` | `clearProperty(String key)` Clear the values pertaining to a particular property.
`Parser` | `createNewParser()` Create a new parser instance.
`boolean` | `dumpVMNamespace(String namespace)` tells the vmFactory to dump the specified namespace.
`boolean` | `evaluate(Context context, Writer writer, String logTag, Reader reader)` Renders the input reader using the context into the output writer.
`boolean` | `evaluate(Context context, Writer out, String logTag, String instring)` Renders the input string using the context into the output writer.
`Object` | `getApplicationAttribute(Object key)` Return the specified application attribute.
`EventCartridge` | `getApplicationEventCartridge()` Returns the event handlers for the application.
`boolean` | `getBoolean(String key, boolean def)` Boolean property accessor method to hide the configuration implementation.
`ExtendedProperties` | `getConfiguration()` Return the velocity runtime configuration object.
`ContentResource` | `getContent(String name)` Returns a static content resource from the resource manager.
`ContentResource` | `getContent(String name, String encoding)` Returns a static content resource from the resource manager.
`Directive` | `getDirective(String name)` Retrieve a previously instantiated directive.
`int` | `getInt(String key)` Int property accessor method to hide the configuration implementation.
`int` | `getInt(String key, int defaultValue)` Int property accessor method to hide the configuration implementation.
`Introspector` | `getIntrospector()` Returns the configured method introspection/reflection implementation.
`String` | `getLoaderNameForResource(String resourceName)` Determines is a template exists, and returns name of the loader that provides it.
`Log` | `getLog()` Returns a convenient Log instance that wraps the current LogChute.
`Object` | `getProperty(String key)` Allows an external caller to get a property.
`String` | `getString(String key)` String property accessor method to hide the configuration implementation
`String` | `getString(String key, String defaultValue)` String property accessor method with default to hide the configuration implementation.
`Template` | `getTemplate(String name)` Returns a `Template` from the resource manager.
`Template` | `getTemplate(String name, String encoding)` Returns a `Template` from the resource manager
`Uberspect` | `getUberspect()` Returns the configured class introspection/reflection implementation.
`Directive` | `getVelocimacro(String vmName, String templateName)` Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`Directive` | `getVelocimacro(String vmName, String templateName, String renderingTemplate)` Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`void` | `init()` This is the primary initialization method in the Velocity Runtime.
`void` | `init(Properties p)` Initialize the Velocity Runtime with a Properties object.
`void` | `init(String configurationFile)` Initialize the Velocity Runtime with the name of ExtendedProperties object.
`boolean` | `invokeVelocimacro(String vmName, String logTag, String[] params, Context context, Writer writer)` Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
`boolean` | `isInitialized()` Returns true if the RuntimeInstance has been successfully initialized.
`boolean` | `isVelocimacro(String vmName, String templateName)` Checks to see if a VM exists
`SimpleNode` | `parse(Reader reader, String templateName)` Parse the input and return the root of AST node structure.
`SimpleNode` | `parse(Reader reader, String templateName, boolean dumpNamespace)` Parse the input and return the root of the AST node structure.
`SimpleNode` | `parse(String string, String templateName)` Wraps the String in a StringReader and passes it off to `parse(Reader,String)`.
`Object` | `setApplicationAttribute(Object key, Object value)` Set the specified application attribute.
`void` | `setConfiguration(ExtendedProperties configuration)` Allow an external system to set an ExtendedProperties object to use.
`void` | `setProperty(String key, Object value)` Allows an external system to set a property in the Velocity Runtime.

Methods inherited from interface org.apache.velocity.runtime.RuntimeLogger
`debug, error, info, warn`

Method Detail

### init

    public void init()

  This is the primary initialization method in the Velocity Runtime. The systems that are setup/initialized here are as follows:
  - Logging System
  - ResourceManager
  - Parser Pool
  - Global Cache
  - Static Content Include System
  - Velocimacro System

### setProperty

    public void setProperty(String key,
                            Object value)

  Allows an external system to set a property in the Velocity Runtime.

  Parameters:
    `key` - property key
    `value` - property value

### setConfiguration

    public void setConfiguration(ExtendedProperties configuration)

  Allow an external system to set an ExtendedProperties object to use. This is useful where the external system also uses the ExtendedProperties class and the velocity configuration is a subset of parent application's configuration. This is the case with Turbine.

  Parameters:
    `configuration` -

### addProperty

    public void addProperty(String key,
                            Object value)

  Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]

  Parameters:
    `key` -
    `value` -

### clearProperty

    public void clearProperty(String key)

  Clear the values pertaining to a particular property.

  Parameters:
    `key` - of property to clear

### getProperty

    public Object getProperty(String key)

  Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.

  Parameters:
    `key` - property to return
  Returns:
    The value.

### init

    public void init(Properties p)

  Initialize the Velocity Runtime with a Properties object.

  Parameters:
    `p` -

### init

    public void init(String configurationFile)

  Initialize the Velocity Runtime with the name of ExtendedProperties object.

  Parameters:
    `configurationFile` -

### parse

    public SimpleNode parse(String string,
                            String templateName)
                     throws ParseException

  Wraps the String in a StringReader and passes it off to `parse(Reader,String)`.

  Throws:
    `ParseException`
  Since:
    1.6

### parse

    public SimpleNode parse(Reader reader,
                            String templateName)
                     throws ParseException

  Parse the input and return the root of AST node structure.
  In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

  Parameters:
    `reader` - inputstream retrieved by a resource loader
    `templateName` - name of the template being parsed
  Returns:
    The AST representing the template.
  Throws:
    `ParseException`

### parse

    public SimpleNode parse(Reader reader,
                            String templateName,
                            boolean dumpNamespace)
                     throws ParseException

  Parse the input and return the root of the AST node structure.

  Parameters:
    `reader` - inputstream retrieved by a resource loader
    `templateName` - name of the template being parsed
    `dumpNamespace` - flag to dump the Velocimacro namespace for this template
  Returns:
    The AST representing the template.
  Throws:
    `ParseException`

### evaluate

    public boolean evaluate(Context context,
                            Writer out,
                            String logTag,
                            String instring)

  Renders the input string using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

  Parameters:
    `context` - context to use in rendering input string
    `out` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `instring` - input string containing the VTL to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
    `IOException` - While rendering to the writer, an I/O problem occured.
  Since:
    Velocity 1.6

### evaluate

    public boolean evaluate(Context context,
                            Writer writer,
                            String logTag,
                            Reader reader)

  Renders the input reader using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

  Parameters:
    `context` - context to use in rendering input string
    `writer` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `reader` - Reader containing the VTL to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
  Since:
    Velocity 1.6

### invokeVelocimacro

    public boolean invokeVelocimacro(String vmName,
                                     String logTag,
                                     String[] params,
                                     Context context,
                                     Writer writer)

  Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
  Note : currently only accepts args to the VM if they are in the context.

  Parameters:
    `vmName` - name of Velocimacro to call
    `logTag` - string to be used for template name in case of error. if null, the vmName will be used
    `params` - keys for args used to invoke Velocimacro, in java format rather than VTL (eg "foo" or "bar" rather than "$foo" or "$bar")
    `context` - Context object containing data/objects used for rendering.
    `writer` - Writer for output stream
  Returns:
    true if Velocimacro exists and successfully invoked, false otherwise.
  Since:
    1.6

### getTemplate

    public Template getTemplate(String name)
                         throws ResourceNotFoundException,
                                ParseErrorException

  Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `input.encoding` property. The default is "ISO-8859-1"

  Parameters:
    `name` - The file name of the desired template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.

### getTemplate

    public Template getTemplate(String name,
                                String encoding)
                         throws ResourceNotFoundException,
                                ParseErrorException

  Returns a `Template` from the resource manager

  Parameters:
    `name` - The name of the desired template.
    `encoding` - Character encoding of the template
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.

### getContent

    public ContentResource getContent(String name)
                               throws ResourceNotFoundException,
                                      ParseErrorException

  Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.

  Parameters:
    `name` - Name of content resource to get
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException`

### getContent

    public ContentResource getContent(String name,
                                      String encoding)
                               throws ResourceNotFoundException,
                                      ParseErrorException

  Returns a static content resource from the resource manager.

  Parameters:
    `name` - Name of content resource to get
    `encoding` - Character encoding to use
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException`

### getLoaderNameForResource

    public String getLoaderNameForResource(String resourceName)

  Determines is a template exists, and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.templateExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.

  Parameters:
    `resourceName` - Name of template or content resource
  Returns:
    class name of loader than can provide it

### getString

    public String getString(String key,
                            String defaultValue)

  String property accessor method with default to hide the configuration implementation.

  Parameters:
    `key` - property key
    `defaultValue` - default value to return if key not found in resource manager.
  Returns:
    String value of key or default

### getVelocimacro

    public Directive getVelocimacro(String vmName,
                                    String templateName)

  Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.

  Parameters:
    `vmName` - Name of velocimacro requested
    `templateName` - Name of the namespace.
  Returns:
    VelocimacroProxy

### getVelocimacro

    public Directive getVelocimacro(String vmName,
                                    String templateName,
                                    String renderingTemplate)

  Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.

  Parameters:
    `vmName` - Name of velocimacro requested
    `templateName` - Name of the namespace.
    `renderingTemplate` - Name of the template we are currently rendering. This information is needed when VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL setting is true and template contains a macro with the same name as the global macro library.
  Returns:
    VelocimacroProxy
  Since:
    Velocity 1.6

### addVelocimacro

    public boolean addVelocimacro(String name,
                                  String macro,
                                  String[] argArray,
                                  String sourceTemplate)

  Deprecated. Use addVelocimacro(String, Node, String[], String) instead

  Adds a new Velocimacro. Usually called by Macro only while parsing.

  Parameters:
    `name` - Name of velocimacro
    `macro` - String form of macro body
    `argArray` - Array of strings, containing the #macro() arguments. the 0th is the name.
    `sourceTemplate` -
  Returns:
    boolean True if added, false if rejected for some reason (either parameters or permission settings)

### addVelocimacro

    public boolean addVelocimacro(String name,
                                  Node macro,
                                  String[] argArray,
                                  String sourceTemplate)

  Adds a new Velocimacro. Usually called by Macro only while parsing.

  Parameters:
    `name` - Name of velocimacro
    `macro` - root AST node of the parsed macro
    `argArray` - Array of strings, containing the #macro() arguments. the 0th is the name.
    `sourceTemplate` -
  Returns:
    boolean True if added, false if rejected for some reason (either parameters or permission settings)
  Since:
    Velocity 1.6

### isVelocimacro

    public boolean isVelocimacro(String vmName,
                                 String templateName)

  Checks to see if a VM exists

  Parameters:
    `vmName` - Name of velocimacro
    `templateName` -
  Returns:
    boolean True if VM by that name exists, false if not

### dumpVMNamespace

    public boolean dumpVMNamespace(String namespace)

  tells the vmFactory to dump the specified namespace. This is to support clearing the VM list when in inline-VM-local-scope mode

  Parameters:
    `namespace` -
  Returns:
    True if the Namespace was dumped.

### getString

    public String getString(String key)

  String property accessor method to hide the configuration implementation

  Parameters:
    `key` - property key
  Returns:
    value of key or null

### getInt

    public int getInt(String key)

  Int property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
  Returns:
    int value

### getInt

    public int getInt(String key,
                      int defaultValue)

  Int property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
    `defaultValue` - default value
  Returns:
    int value

### getBoolean

    public boolean getBoolean(String key,
                              boolean def)

  Boolean property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
    `def` - default default value if property not found
  Returns:
    boolean value of key or default value

### getConfiguration

    public ExtendedProperties getConfiguration()

  Return the velocity runtime configuration object.

  Returns:
    ExtendedProperties configuration object which houses the velocity runtime properties.

### getApplicationAttribute

    public Object getApplicationAttribute(Object key)

  Return the specified application attribute.

  Parameters:
    `key` - The name of the attribute to retrieve.
  Returns:
    The value of the attribute.

### setApplicationAttribute

    public Object setApplicationAttribute(Object key,
                                          Object value)

  Set the specified application attribute.

  Parameters:
    `key` - The name of the attribute to set.
    `value` - The attribute value to set.
  Returns:
    the displaced attribute value

### getUberspect

    public Uberspect getUberspect()

  Returns the configured class introspection/reflection implementation.

  Returns:
    The current Uberspect object.

### getLog

    public Log getLog()

  Returns a convenient Log instance that wraps the current LogChute.

  Returns:
    A log object.

### getApplicationEventCartridge

    public EventCartridge getApplicationEventCartridge()

  Returns the event handlers for the application.

  Returns:
    The event handlers for the application.

### getIntrospector

    public Introspector getIntrospector()

  Returns the configured method introspection/reflection implementation.

  Returns:
    The configured method introspection/reflection implementation.

### isInitialized

    public boolean isInitialized()

  Returns true if the RuntimeInstance has been successfully initialized.

  Returns:
    True if the RuntimeInstance has been successfully initialized.

### createNewParser

    public Parser createNewParser()

  Create a new parser instance.

  Returns:
    A new parser instance.

### getDirective

    public Directive getDirective(String name)

  Retrieve a previously instantiated directive.

  Parameters:
    `name` - name of the directive
  Returns:
    the directive with that name, if any
  Since:
    1.6

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2010 Apache Software Foundation. All Rights Reserved.